#!/bin/sh

export LC_ALL=POSIX
SYSTEMCTL=systemctl

a= . install2-init-functions

set_type_units() {
    ACTION=$1
    shift
    UNITTYPE=$1
    shift
    while [ -n "$1" ]
    do
	exec_chroot $SYSTEMCTL $ACTION ${1}.${UNITTYPE} ||:
	shift
    done
}

# set TMPDIR to /tmp/.private/LOGNAME
exec_chroot control pam_mktemp enabled ||:

# turn off tmpfs
sed -i 's|^tmpfs|#tmpfs|' $destdir/etc/fstab ||:

# turn off systemd tmp.mount
# don't mask because systemd local fs mount bug ALT#29066
#set_type_units mask mount tmp

# find free space for /tmp
BEST_SPACE=0
BEST_MP=
while read DEV MP X
do
    echo "$DEV" | grep -qe '^UUID=' || echo "$DEV" | grep -qe '^/dev/' || continue
    echo "$MP" | grep -qe '^/' || continue

    # tmpdir already configured
    if [ "$MP" == "/tmp" ]; then
	BEST_MP=
	((BEST_SPACE=0))
	break
    fi

    INSTALLER_TEST_FILE="${destdir}/${MP}/_INSTALLER_TEST_FILE_"

    # check for writing
    touch "$INSTALLER_TEST_FILE" || continue
    # check for permissions
    if ! chmod --quiet 1777 "$INSTALLER_TEST_FILE" ; then
	rm -f "$INSTALLER_TEST_FILE" ||:
	continue
    fi
    NEW_PERMS=`stat --printf='%a' "$INSTALLER_TEST_FILE"`
    if [ "$NEW_PERMS" != "1777" ] ; then
	rm -f "$INSTALLER_TEST_FILE" ||:
	continue
    fi
    # check for execution
    echo -e '#!/bin/sh\n\necho "Execution possible"' > "$INSTALLER_TEST_FILE"
    if [ -z "`$INSTALLER_TEST_FILE`" ] ; then
	rm -f "$INSTALLER_TEST_FILE" ||:
	continue
    fi

    # check for free space
    MP_SPACE=$(echo `/bin/df "$destdir/$MP"| tail -n 1`| cut -d\  -f 4)
    if (($MP_SPACE > $BEST_SPACE)) ; then
	BEST_MP=$MP
	((BEST_SPACE=$MP_SPACE))
    fi

    rm -f "$INSTALLER_TEST_FILE" ||:
done < $destdir/etc/fstab

if (($BEST_SPACE > 0)) && [ -n "$BEST_MP" -a "$BEST_MP" != "/" -a ! -d "$destdir/$BEST_MP/tmp" ]
then

    # setup tmp mount point
    cp -ar $destdir/tmp "$destdir/$BEST_MP"/ ||:
    echo -e "$BEST_MP/tmp\t/tmp\tauto\tbind,rw,nosuid,nodev\t0\t0" >> $destdir/etc/fstab ||:
fi
